<?php

/**
 * @package Statiny addon
 * @copyright Copyright 2016 Statiny bot
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 */


if (!empty($_REQUEST['main_page']) && $_REQUEST['main_page'] == 'checkout_success')
{
    function asyncReq($url, $params)
    {
        foreach ($params as $key => &$val)
        {
            if (is_array($val))
                $val = implode(',', $val);

            $post_params[] = $key.'='.urlencode($val);
        }

        $post_string = implode('&', $post_params);

        $parts = parse_url($url);

        $fp = fsockopen($parts['host'], isset($parts['port'])?$parts['port']:80, $errno, $errstr, 30);

        $out = "POST ".$parts['path']." HTTP/1.1\r\n";
        $out.= "Host: ".$parts['host']."\r\n";
        $out.= "Content-Type: application/x-www-form-urlencoded\r\n";
        $out.= "Content-Length: ".strlen($post_string)."\r\n";
        $out.= "Connection: Close\r\n\r\n";

        if (isset($post_string))
            $out.= $post_string;

        fwrite($fp, $out);
        fclose($fp);
    }

	$orders_query = "SELECT * FROM " . TABLE_ORDERS . "
                 WHERE customers_id = :customersID
                 ORDER BY date_purchased DESC LIMIT 1";
	$orders_query = $db->bindVars($orders_query, ':customersID', $_SESSION['customer_id'], 'integer');
	$orders = $db->Execute($orders_query);
	$orders_id = $orders->fields['orders_id'];

	if (!empty($orders_id))
	{
		if (!in_array($orders_id, $_SESSION['send_order']))
		{
            $_SESSION['send_order'][] = $orders_id;

            $result = $db->Execute("select * from " . TABLE_CONFIGURATION . " where configuration_key='STATINY_API_KEY' LIMIT 1");

            if (!empty($result->fields['configuration_value']))
            {
                $order = $orders->fields;

                // default currency
                $currency_default_sql = $db->Execute("select * from " . TABLE_CONFIGURATION . " where configuration_key='DEFAULT_CURRENCY' LIMIT 1");
                $currency_default = $currency_default_sql->fields['configuration_value'];

                $data = array (
                    'auth' => array (
                        'api_key' => $result->fields['configuration_value']
                    ),
                    'order_id'   => $order['orders_id'],
                    'company_id' => '',
                    'total'      => $order['order_total'],
                    'currency'   => $currency_default,
                    'timestamp'  => strtotime($order['date_purchased']),
                    'link'       => '',
                    'country'	 => $order['delivery_country'],
                    'state' 	 => $order['delivery_state'],
                    'city'		 => $order['delivery_city'],
                    'uid'		 => md5(empty($order['customers_telephone']) ? $order['customers_email_address'] : $order['customers_telephone']),
                );

                $products_query = "SELECT products_id, products_name, products_model, products_price, products_quantity
                     FROM " . TABLE_ORDERS_PRODUCTS . "
                     WHERE orders_id = :ordersID
                     ORDER BY products_name";
                $products_query = $db->bindVars($products_query, ':ordersID', $order['orders_id'], 'integer');
                $products = $db->Execute($products_query);

                while (!$products->EOF)
                {
                    $order_product = $products->fields;

                    $cPath = zen_get_product_path((int)$order_product['products_id']);
                    $cPath_array = zen_parse_category_path($cPath);
                    $cPath = implode('_', $cPath_array);
                    $product_cat_id = $cPath_array[(sizeof($cPath_array)-1)];

                    $sql = "select categories_name
            from   " . TABLE_CATEGORIES_DESCRIPTION . "
            where  categories_id = " . (int)$product_cat_id . " AND language_id = '" . (int)$_SESSION['languages_id'] . "'";

                    $category_name_row = $db->Execute($sql);

                    $data['products'][] = array (
                        'product_id'   => $order_product['products_id'],
                        'product'      => $order_product['products_name'],
                        'amount'       => $order_product['products_quantity'],
                        'price'        => $order_product['products_price'],
                        'product_code' => $order_product['products_model'],
                        'category_id'  => $product_cat_id,
                        'category'     => $category_name_row ? $category_name_row->fields['categories_name'] : '',
                    );

                    $products->MoveNext();
                }

                $string_data = json_encode($data);

                asyncReq('http://api.statiny.com/' . 'post_event', array('data' => $string_data));
            }
		}
	}
}